<?php

error_reporting( E_ALL );

$trials = 1000000;

$string = '<a href="http://google.com/" title="spam!">Viagra!</a><a href="http://google.com/another/spammy/link" title="SEO Black Hattery!">Google juice</a><a href="http://google.com/" title="spammy">Viagra!</a>';
$encoded_string = base64_encode( $string );
$eval_string = base64_encode( "echo '$string';" );

echo "String Size:  " . strlen( $string ) . "\n";
echo "Encoded Size: " . strlen( $encoded_string ) . "\n";
echo "Eval Size:    " . strlen( $eval_string ) . "\n\n";

$functions = array(
	array(
		'function' => 'test_encoded',
		'arg'      => $encoded_string,
	),
	array(
		'function' => 'test_unencoded',
		'arg'      => $string,
	),
	array(
		'function' => 'text_eval',
		'arg'      => '',
	),
);



$results = array();

for ( $count = 0; $count < $trials; $count++ ) {
	$function_data = $functions[ rand( 0, count( $functions ) - 1 ) ];
	
	if ( ! isset( $results[$function_data['function']] ) ) {
		$results[$function_data['function']] = array(
			'trials'       => 0,
			'total_memory' => 0,
			'max_memory'   => 0,
			'total_time'   => 0,
			'trial_time'   => array(),
			'total_count'  => 0,
		);
	}
	
	run_trial( $function_data['function'], $function_data['arg'] );
}

foreach ( $functions as $function_data ) {
	$result = $results[$function_data['function']];
	
	echo "{$function_data['function']}\n";
	echo "==========================\n";
	echo "Trials:           {$result['trials']}\n";
	echo "Total Memory:     {$result['total_memory']}\n";
	echo "Average Memory:   " . ( $result['total_memory'] / $result['trials'] ) . "\n";
	echo "Max Memory:       {$result['max_memory']}\n";
	echo "Total Time:       {$result['total_time']}\n";
	echo "Average Time:     " . sprintf( '%.10f', ( $result['total_time'] / $result['trials'] ) ) . "\n";
	echo "Runs per Sec:     " . ( 1 / ( $result['total_time'] / $result['trials'] ) ) . "\n";
	
	if ( isset( $results['no_cast']['total_time'] ) )
		echo "Speed Difference: " . ( ( $result['total_time'] - $results['no_cast']['total_time'] ) / $results['no_cast']['total_time'] ) . "\n";
	
	echo "\n";
}



function run_trial( $function, $arg, $count = 1 ) {
	global $results, $data;
	
	
	$memory = 0;
	$time = 0;
	$total_count = 0;
	
	for ( $i = 0; $i < $count; $i++ ) {
		ob_start();
		$start_memory = memory_get_usage();
		$start = microtime( true );
		
		@call_user_func( $function, $arg );
		
		$end = microtime( true );
		$end_memory = memory_get_usage();
		ob_end_clean();
		
		$time += $end - $start;
		$memory += $end_memory - $start_memory;
		
		$total_count++;
	}
	
	
	$results[$function]['trials']++;
	$results[$function]['total_memory'] += $memory;
	$results[$function]['total_time'] += $time;
	$results[$function]['total_count'] += $total_count;
	
	if ( $memory > $results[$function]['max_memory'] )
		$results[$function]['max_memory'] = $memory;
}


function test_encoded( $encoded_string ) {
	echo base64_decode( $encoded_string );
}

function test_unencoded( $string ) {
	echo $string;
}

function test_eval( $string ) {
	eval( base64_decode( $string ) );
}
